package pl.mpak.sky.gui.swing.syntax.structure.core;

import pl.mpak.sky.gui.swing.syntax.structure.BlockElement;

public class CodeElement {
  
  private int index;
  private String codeName;
  private int startOffset;
  private int endOffset;
  private CodeElement owner;

  public CodeElement(CodeElement owner, String codeName) {
    super();
    this.owner = owner;
    this.codeName = codeName;
  }
  
  protected void finalize() throws Throwable {
    super.finalize();
  }

  public String getCodeName() {
    return codeName;
  }

  public void setCodeName(String codeName) {
    this.codeName = codeName;
  }

  public int getStartOffset() {
    return startOffset;
  }

  public CodeElement getOwner() {
    return owner;
  }

  public void setStartOffset(int startOffset) {
    this.startOffset = startOffset;
  }

  public int getEndOffset() {
    return endOffset;
  }

  public void setEndOffset(int length) {
    this.endOffset = length;
  }
  
  public int getIndex() {
    return index;
  }

  public void setIndex(int index) {
    this.index = index;
  }

  public CodeElement getElementAt(int offset) {
    if (offset >= startOffset && offset <= endOffset) {
      return this;
    }
    return null;
  }
  
  public BlockElement getRootBlock() {
    CodeElement e = getOwner();
    if (e == null && this instanceof BlockElement) {
      return (BlockElement)this;
    }
    while (e != null) {
      if (e.getOwner() == null && e instanceof BlockElement) {
        return (BlockElement)e;
      }
      e = e.getOwner();
    }
    return null;
  }

  public String toString() {
    return "startOffset=" +startOffset +",endOffset=" +endOffset;
  }
  
}
