package pl.mpak.usedb.core;

import java.sql.SQLException;
import java.util.EventListener;
import java.util.EventObject;

/**
 * @author akaluza
 * <p>Listener w ktrym zwraca si informacj o tym czy polecenie e.getSource() moe by wykonane.
 * <p>Listener wywoywany jest w Command.execeute() lub Query.open() jeszcze przed jakimkolwiek innym sprawdzeniem lub zdaeniem.
 */
public interface ExecutableListener extends EventListener {

  /**
   * <p>Powinno zwrci informacj czy polecenie moe by wykonane czy nie.
   * @param e
   * @return
   * @throws SQLException
   */
  public boolean canExecute(EventObject e) throws SQLException;

}
